#include "descriptor/descriptor.h"

int main(void) {

  ITEM	vetro,colore,colore2,colore3;
  ITEM  tavolo,piede,lamp,lampadina,tubo,scena;
  
  set_background(0.676,0.861,0.953,TRUE);
  set_ambient_light(1,1,1,0.7);
//  create_point_light(0,0,12,1,1,1,4,20, "luce_1");
//  create_point_light(12,-12,9,1,1,1,4,20, "luce_2");
//  create_point_light(2.33,-0.25,16.21,1,1,1,3.89,25, "luce_3");

  create_point_light(-1.2,0,0,1,1,1,4,20, "luce_lampada");

		  
  /*** ATTRIBUTO vetro ***/
  vetro = create_attribute("vetro");
  set_color(vetro,0.68,0.86,1,0.5,0.5);
  set_reflectivity(vetro,0.24,2);
  set_transparency(vetro,0.87,0.68,1,1.2);

  /*** ATTRIBUTO colore ***/
  colore = create_attribute("colore");
  set_color(colore,0,0.5,1,0.5,0.5);
  set_reflectivity(colore,0.3,10);

  /*** ATTRIBUTO colore2 ***/
  colore2 = create_attribute("colore2");
  set_color(colore2,0.5,0,0,0.5,0.5);
  set_reflectivity(colore2,0.3,10);
  
  /*** ATTRIBUTO colore3 ***/
  colore3 = create_attribute("colore3");
  set_color(colore3,0.05,0.45,1,0.5,0.5);
  set_reflectivity(colore3,0.3,10);
  
  /*** TAVOLO ***/
  tavolo = create_list(read_nurbs("r2tavolo.db"), "tavolo");
  piede = read_nurbs("r2piede.db");
  set_translate(piede,1,1,-1.5);
  tavolo = insert_in_list(tavolo, create_copy(piede,"p1"));
  set_translate(piede,-2,0,0);
  tavolo = insert_in_list(tavolo, create_copy(piede,"p2"));
  set_translate(piede,0,-2,0);
  tavolo = insert_in_list(tavolo, create_copy(piede,"p3"));
  set_translate(piede,2,0,0);
  tavolo = insert_in_list(tavolo, create_copy(piede,"p4"));

  /*** TAVOLO scalato e posizionato ***/
  set_translate(tavolo,0.5,0.3,-1.8);
  
  /*** LAMPADA ***/
  lamp = create_list(read_nurbs("r3lampadina.db"), "lamp");
  
  /*** TUBO E BASE ***/
  tubo = create_list(read_nurbs("r2tubostorto.db"), "tubo");
  tubo = insert_in_list(tubo, read_nurbs("r2base.db"));
  
  /*** LAMPADINA ***/
  lampadina = create_list(read_nurbs("r3lampadina.db"), "lampadina");
  
  set_attribute(lamp,colore);
  set_attribute(lampadina,vetro);
  set_attribute(tubo,colore3);
  set_attribute(tavolo,colore2);
  
  set_scale(lamp,1.5,1.5,1.5);
  set_scale(lampadina,1.5,1.5,1.5);
  set_scale(tubo,1.5,1.5,1.5);
  
  scena = create_list(lamp, "scena");
  scena = insert_in_list(scena,tubo);
  scena = insert_in_list(scena,lampadina);
  scena = insert_in_list(scena,tavolo);
  
  save_scene("lamp.md","scena",scena);
  return(0);
}
